/**
 * 
 */
package com.test.ejb;

import java.util.Hashtable;
import java.util.Properties;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.jboss.ejb.client.ContextSelector;
import org.jboss.ejb.client.EJBClientConfiguration;
import org.jboss.ejb.client.EJBClientContext;
import org.jboss.ejb.client.PropertiesBasedEJBClientConfiguration;
import org.jboss.ejb.client.remoting.ConfigBasedEJBClientContextSelector;

import com.bally.romsig.service.ITestRemote;
import com.brad.j2ee.jboss.ejb.AllClusterNodeSelector;

/**
 * 
 * @author vbalajiprasath
 * 
 */
public final class FailoverAndRetryEJBTest {

	static final String APP_SERVER = "APPSERVER_";

	private static ITestRemote lookup()
			throws NamingException {
		final Hashtable<String, Object> jndiProps = new Hashtable<String, Object>();
		jndiProps.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming");
		final Context context = new InitialContext(jndiProps);
		String lookupName = "ejb:APP/APPEngine/TestRemote!com.service.ITestRemote";
		System.out.println("lookupName=" + lookupName);

		ITestRemote te = (ITestRemote) context.lookup(lookupName);
		return te;
	}

	public static void createClusterEJBClientContext(String clusterName, int port,  String... ipAddress) {
		StringBuilder sb = new StringBuilder();
		for (int i = 0; i < ipAddress.length; i++) {
			sb.append(APP_SERVER).append(i).append(",");
		}
		sb.deleteCharAt(sb.length() - 1);
		String serverNameList = sb.toString();
		Properties properties = new Properties();
		properties.put("remote.connections", serverNameList);
		properties.put("remote.connectionprovider.create.options.org.xnio.Options.SSL_ENABLED","false");

		for (int i = 0; i < ipAddress.length; i++) {
			properties.put("remote.connection." + APP_SERVER + i + ".connect.options.org.xnio.Options.SASL_DISALLOWED_MECHANISMS", "JBOSS-LOCAL-USER");
			properties.put("remote.connection." + APP_SERVER + i + ".connect.options.org.xnio.Options.SASL_POLICY_NOANONYMOUS", "false");
			properties.put("remote.connection." + APP_SERVER + i + ".host",ipAddress[i].trim());
			properties.put("remote.connection." + APP_SERVER + i + ".port",String.valueOf(port));
			properties.put("remote.connection." + APP_SERVER + i + ".username","sds");
			properties.put("remote.connection." + APP_SERVER + i + ".password","bally@123");
		}

		properties.put("invocation.timeout", "3000");
		properties.put("reconnect.tasks.timeout", "2000");

		properties.put("remote.clusters", clusterName);
		properties.put("remote.cluster."+clusterName+".connect.options.org.xnio.Options.SSL_ENABLED", "false");
		properties.put("remote.cluster."+clusterName+".connect.options.org.xnio.Options.SASL_POLICY_NOANONYMOUS", "false");
		properties.put("remote.cluster."+clusterName+".connect.options.org.xnio.Options.SASL_DISALLOWED_MECHANISMS", "JBOSS-LOCAL-USER");
		properties.put("clusternode.selector", AllClusterNodeSelector.class.getName());
	
		EJBClientConfiguration ejbClientConf = new PropertiesBasedEJBClientConfiguration(properties);

		ContextSelector<EJBClientContext> selector = new ConfigBasedEJBClientContextSelector(ejbClientConf);
		EJBClientContext.setSelector(selector);
	
	}

	public static void main(String[] args) {
		try {
			createClusterEJBClientContext("ejb" ,4447, "10.2.44.106","10.2.44.109");
			for(int i=1;i<1000;i++){
				try{
					Thread.sleep(1000l);
				}catch(Exception e){
					e.printStackTrace();
				}
				ITestRemote testRemote1 = lookup();
				try{
					System.out.println(testRemote1.print("Req No ="+i));
				}catch(Exception e){
					e.printStackTrace();
				}
			}
		} catch (NamingException e) {
			e.printStackTrace();
		}

	}



}
